<?php
/*
Plugin Name: ecSTATic
Plugin URI: http://www.kayak2u.com/blog/ecstatic/
Description: Faster, Smaller, Non-Ecological Real-Time Visitor Stats and Management for Wordpress Blogs
Version: 0.81
Author: MikeSoja, BVD
Author URI: http://www.kayak2u.com/blog/ecstatic/
*/

/***********************************************************************************/
class ecstatic {
public $version = '0.81';
public $url = "";
public $schost = "";
public $bob = "";
public $datetime = '';
public $timezoneoffset = 0;
public $score = 0;
public $options = array();
public $option_defaults = array("showbannergraph" => 1, "showgraphregi" => 1, "showgraphregp" => 1, "showgraphfeedi" => 1, "showgraphfeedp" => 0, "showgraphboti" => 1, "showgraphbotp" => 0, "showreg" => 1, "showfeed" => 1, "showbot" => 1, "collectloggeduser" => 0, "daystograph" => 30, "purgeolderthan" => 30, "purgerssolderthan" => 30, "purgebotolderthan" => 30, "daystoshow" => 1, "maxtoshow" => 64, "newvisitorminutes" => 60, "mal_ip" => 10, "empty_ua" => 7, "empty_ref" => 3, "mal_uri" => 10, "trackback" => 3, "login" => 6, "lostpassword" => 6, "panel1" => "reg", "panel2" => "feed", "panel3" => "bot", "topentriestoshow" => 25, "graphsort" => 0, "noprefetch" => 1, "enablewidget" => 0);
//changes to options must be made in five (six, if a string option is changed) places.
//$option_defaults above
//ecstatic_tables.php ecstatic_create_table
//ecstatic_tables.php ecstatic_populate_table - if the new option is a string
//ecstatic_tables.php ecstatic_versionista
//ecstatic_forms.php process_option_changes - three places
//ecstatic_forms.php option_form

/***********************************************************************************/
function get_options() {
global $wpdb;
$table_name = $this->make_table("options");
$this->options = $wpdb->get_row("SELECT * FROM $table_name", ARRAY_A);
foreach ($this->option_defaults as $key => $value) {
	if (!isset($this->options[$key]))
		$this->options[$key] = $value;
		}
$this->url = get_option("siteurl");
$base = parse_url($this->url);
$this->schost = $base["scheme"] . "://" . $base["host"];
$len = strlen($this->schost);
if (strlen($this->url) > $len)
	$this->bob = substr($this->url, $len);

$this->timezoneoffset = get_option("gmt_offset");
if ($this->version != $this->options["version"]) {
	include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_tables.php');
	ecstatic_versionista($this);
	}
} //get_options

/***********************************************************************************/
function make_table($tana) {
global $wpdb;
$table_name = $wpdb->prefix . "ecstatic_" . $tana;
if ($wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name) {
	include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_tables.php');
	ecstatic_create_table($tana, $this);
	ecstatic_populate_table($tana, $this);
	}
return $table_name;
} //make_table

/***********************************************************************************/
function validate_ip($ip, $ip2test="") {
$valid_min = $valid_max = "";
$min = str_replace("*", "000", $ip);
$min = str_replace("?", "0", $min);
$max = str_replace("*", "255", $ip);
$max = str_replace("?", "9", $max);
$min_octets = explode(".", $min);
$max_octets = explode(".", $max);
$min = $max = 1;
for ($i=0; $i<4; $i++) {
	if (strpos($min_octets[$i],"-") !== false) {
		$range_split = explode("-", $min_octets[$i]);
		$min_octets[$i] = $range_split[0];
		$max_octets[$i] = $range_split[1];
		}
	if ($min_octets[$i] > 255)
		$min_octets[$i] = 0;
	if ($max_octets[$i] > 255)
		$max_octets[$i] = 255;
	$min .= sprintf("%03d", $min_octets[$i]);
	$valid_min .= sprintf("%d", $min_octets[$i]);
	$max .= sprintf("%03d", $max_octets[$i]);
	$valid_max .= sprintf("%d", $max_octets[$i]);
	if ($i < 3) {
		$valid_min .= ".";
		$valid_max .= ".";
		}
	}
if($valid_min != long2ip(ip2long($valid_min)) OR $valid_max != long2ip(ip2long($valid_max)))
	return false;
if (($ip2test != "") AND ($ip2test >= $min) AND ($ip2test <= $max))
	return true;
return 2;
} //validate_ip

/***********************************************************************************/
function killing_and_telling($ip2check, $ua2check, $ref2check, $vein=0, $which=0) {
global $wpdb;
$bf = array("BANNED", "FOUND", "FOUND", "FOUND");
$ua2check = str_replace(" ", "", strtolower($ua2check));
$killspider = array("aux_kill", "aux_spider", "aux_nolog", "aux_wlist"); //$vein
$table_name = $this->make_table($killspider[$vein]);
$ks_query = array("SELECT name, token, type FROM $table_name","SELECT name, token, type FROM $table_name WHERE type='ip'"); //$which
$octets = explode(".", $ip2check);
$ip2test = "1" . sprintf("%03d", $octets[0]) . sprintf("%03d", $octets[1]) . sprintf("%03d", $octets[2]) . sprintf("%03d", $octets[3]);
$record = $wpdb->get_results($ks_query[$which]);
foreach ($record as $rec) {
	switch ($rec->type) {
		case "ip":
			$verdict = $this->validate_ip($rec->token, $ip2test);
			if ($verdict === false) {
				$rec->verdict = "Invalid: " . $rec->token;
				return $rec;
				}
			elseif ($verdict === true) {
				$rec->verdict = $bf[$vein];
				return $rec;
				}
			break;
		case "ua":
			if (strpos($ua2check, $rec->token) !== false) {
				$rec->verdict = "found";
				return $rec;
				}
			break;
		case "ref":
			if (strpos($ref2check, $rec->token) !== false) {
				$rec->verdict = "found";
				return $rec;
				}
			break;
		} //switch
	} //foreach
return "";
} //killing_and_telling

/******************************************CONSTRUCTOR****************************/
function __construct() {
if (function_exists("date_default_timezone_set"))
	date_default_timezone_set(get_option('timezone_string'));
$this->datetime = time();
$this->get_options();
} //ecstatic constructor
} //class ecstatic
/***********************************************************************************/

/***********************************************************************************/
class act extends ecstatic {

public $ip = ''; //REMOTE_ADDR
private $ua = ''; //HTTP_USER_AGENT
private $ref = ''; //HTTP_REFERER
public $ruri = ''; //REQUEST_URI
private $cookie = ''; //unused

/***********************************************************************************/
function hit_parade() {
global $wpdb;

if (isset($_SERVER['HTTP_X_MOZ'])) {
	if ($_SERVER['HTTP_X_MOZ'] == 'prefetch' AND $this->options["noprefetch"]) {
	    header('HTTP/1.0 403 Forbidden');
    	exit("403: Forbidden<br><br>Prefetching not allowed.");
    	}
	}
$this->ip = $_SERVER['REMOTE_ADDR'];
$this->ua = (isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '');
$this->ref = (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '');
//$this->ruri = (isset($_SERVER["REQUEST_URI"]) ? $_SERVER["REQUEST_URI"] : '');
if (isset($_SERVER['REQUEST_URI']))
	$this->ruri = $_SERVER['REQUEST_URI'];
elseif (isset($_SERVER['QUERY_STRING']))
	$this->ruri = $_SERVER['SCRIPT_NAME'] .'?'. $_SERVER['QUERY_STRING'];
elseif (isset($_SERVER['argv']))
		$this->ruri = $_SERVER['SCRIPT_NAME'] .'?'. $_SERVER['argv'][0]; //substr($_SERVER['argv'][0], strpos($_SERVER['argv'][0], ';') + 1)
else
	$this->ruri = $_SERVER['SCRIPT_NAME'];
$this->ruri = '/'. ltrim($this->ruri, '/');

if ($this->ip == "") //does this ever happen???
	$this->score += $this->options["mal_ip"]; //default: 10 = kill
else {
	if ($kill = $this->killing_and_telling($this->ip, $this->ua, $this->ref)) { //aux_kill all parameters
		$ls = $this->make_table("aux_kill"); //keep track of kills
		$wpdb->query($wpdb->prepare("UPDATE $ls SET lastseen=%s WHERE token=%s", $this->datetime, $kill->token));
		$this->score += $this->options["mal_ip"];
		}
	}
if ($this->ua == "")
	$this->score += $this->options["empty_ua"];
if (strpos($this->ref, $this->schost) === 0) //don't record one's own referrals
	$this->ref = "";
if ($this->ref == "")
	$this->score += $this->options["empty_ref"];
if (strpos($this->ruri, "http://") !== false) //catch some malformed Requested URIs
	$this->score += $this->options["mal_uri"];
if (strpos($this->ruri, "wp-login.php") !== false)
	$this->score += $this->options["login"];
if (strpos($this->ruri, "lostpassword") !== false)
	$this->score += $this->options["lostpassword"];
if (strpos($this->ruri, "wp-trackback") !== false)
	$this->score += $this->options["trackback"];
if (preg_match("/.css$|.js$|.ico$/i", $this->ruri))
	return false;
if (stristr($this->ruri, "/wp-content/plugins") == true)
	return false;
if (stristr($this->ruri, "/wp-content/themes") == true)
	return false;
if ($this->ip == "127.0.0.1")
	return false;
return true;
} //hit_parade

/***********************************************************************************/
function append_hit() {
global $wpdb;
$tablez = array("ip"=>"ips", "ua"=>"user_agents", "ref"=>"refs", "ruri"=>"ruris"); //ruri must be last
$knowz = array("ip" => $this->ip, "ref" => $this->ref, "ruri" => $this->ruri);
$idz = array("ip" => 0, "ua" => 0, "ref" => 0, "ruri" => 0);
$type = "reg";
if (strpos($this->ruri, "feed") !== false)
	$type = "feed";
foreach ($tablez as $key=>$val) {
	$rtable = $this->make_table($val);
	switch ($key) {
		case "ua":
			$row = $wpdb->get_row($wpdb->prepare("SELECT id, aux, score FROM $rtable WHERE ua=%s", $this->ua));
			if ($row->aux == 2) //don't question it
				$type = "bot";
			else {
				if (preg_match("/bot|spider|crawl/i", $this->ua) OR $this->killing_and_telling($this->ip, $this->ua, "", 1, 0)) { //aux_spider, all parms
					$wpdb->query($wpdb->prepare("UPDATE $rtable SET aux=%d WHERE id=%d", 2, $row->id));
					$type = "bot";
					}
				}
			break;
		case "ip":
		case "ref":
		case "ruri":
			$row = $wpdb->get_row($wpdb->prepare("SELECT id, score FROM $rtable WHERE $key=%s", $knowz[$key]));
			break;
		} //switch

	if ($row->id) {
		$idz[$key] = $row->id;
		$this->score += $row->score;
		}
	else {
		switch ($key) {
			case "ua": //id, ua, aux, browser, os, renderer, score
				$wpdb->query($wpdb->prepare("INSERT INTO $rtable VALUES (null, %s, DEFAULT, DEFAULT, DEFAULT, DEFAULT, DEFAULT)", $this->ua));
				break;
			case "ip": //id, ip, aux, score, domain
				$wpdb->query($wpdb->prepare("INSERT INTO $rtable VALUES (null, %s, DEFAULT, DEFAULT, %s)", $this->ip, ""));
				break;
			case "ref": //id, ref, aux, score
				$wpdb->query($wpdb->prepare("INSERT INTO $rtable VALUES (null, %s, DEFAULT, DEFAULT)", $this->ref));
				break;
			case "ruri": //id, ruri, aux, score
				$aux = 0; //must change default in ruri table
				$wpdb->query($wpdb->prepare("INSERT INTO $rtable VALUES (null, %s, %d, DEFAULT)", $this->ruri, $aux));
				break;
			} //switch
		if (mysql_affected_rows() > 0)
			$idz[$key] = mysql_insert_id();
		}
	} //foreach
if ($wlist = $this->killing_and_telling($this->ip, $this->ua, $this->ref, 3)) { //aux_wlist all parameters
	$ls = $this->make_table("aux_wlist");
	$wpdb->query($wpdb->prepare("UPDATE $ls SET lastseen=%s WHERE token=%s", $this->datetime, $wlist->token));
	$this->score = -1;
	}
if ($nolog = $this->killing_and_telling($this->ip, $this->ua, $this->ref, 2)) { //aux_nolog all parameters
	$ls = $this->make_table("aux_nolog"); //keep track of no log
	$wpdb->query($wpdb->prepare("UPDATE $ls SET lastseen=%s WHERE token=%s", $this->datetime, $nolog->token));
	}
else {
	$thrashed = 0;
	$table = $this->make_table("hits");
	if ($this->score < 10) {
		$t = $this->make_table("cumulative");
		$ind = array("reg" => "UPDATE $t SET regi=regi+1 WHERE day=%d", "bot" => "UPDATE $t SET boti=boti+1 WHERE day=%d", "feed" => "UPDATE $t SET feedi=feedi+1 WHERE day=%d");
		$page = array("reg" => "UPDATE $t SET regp=regp+1 WHERE day=%d", "bot" => "UPDATE $t SET botp=botp+1 WHERE day=%d", "feed" => "UPDATE $t SET feedp=feedp+1 WHERE day=%d");
		$big_today = $this->datetime - ($this->datetime + (60 * 60 * $this->timezoneoffset)) % (60*60*24); //midnight zero
		$today = gmdate("Ymd", $big_today);
		$cutoff = $this->datetime - ($this->options["newvisitorminutes"] * 60);
		$thrash = $this->datetime - 30;
		if (!$wpdb->get_var($wpdb->prepare("SELECT count(*) FROM $t WHERE day=%d",$today)))
			$wpdb->query($wpdb->prepare("INSERT INTO $t VALUES (%d, DEFAULT, DEFAULT, DEFAULT, DEFAULT, DEFAULT, DEFAULT)", $today));
		if (!$thrashed = $wpdb->get_var($wpdb->prepare("SELECT count(*) FROM $table WHERE ip=%d AND ua=%d AND ruri=%d AND datetime>%d",$idz["ip"],$idz["ua"],$idz["ruri"],$thrash))) {
			$wpdb->query($wpdb->prepare($page[$type],$today));
			if ($type != "bot")
				$wpdb->query($wpdb->prepare("UPDATE $rtable SET aux=aux+1 WHERE id=%d", $idz["ruri"])); //page visits
			}
		if ($type != "reg" AND !$wpdb->get_var($wpdb->prepare("SELECT count(*) FROM $table WHERE ip=%d AND ua=%d AND datetime>%d",$idz["ip"],$idz["ua"],$big_today)))
			$wpdb->query($wpdb->prepare($ind[$type],$today));
		elseif ($type == "reg" AND !$wpdb->get_var($wpdb->prepare("SELECT count(*) FROM $table WHERE ip=%d AND ua=%d AND datetime>%d",$idz["ip"],$idz["ua"],$cutoff)))
			$wpdb->query($wpdb->prepare($ind[$type],$today));
		}
	if (!$thrashed)
		$wpdb->query($wpdb->prepare("INSERT INTO $table (datetime, ip, ua, ref, ruri, cookie, score) VALUES (%s, %d, %d, %d, %d, %s, %d)", $this->datetime, $idz["ip"], $idz["ua"], $idz["ref"], $idz["ruri"], $this->cookie, $this->score));
	}
} //append_hit

/***********************************************************************************/
function __construct() {
parent::__construct();
} //constructor
} //class act

/***********************************************************************************/
function ecstatic_new_hit() {
if (isset($_POST["ecstatit"])) { //must go here to beat any header output
	include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_forms.php');
	$ecstatic = new ecstatic_formproc();
	$ecstatic->form_processor(); //function exit()s and doesn't return
	}
$ecstatic = new act();
if (!is_user_logged_in() OR $ecstatic->options["collectloggeduser"])
	if ($ecstatic->hit_parade())
		$ecstatic->append_hit();
if ($ecstatic->score > 9) {
    header('HTTP/1.0 403 Forbidden');
	exit("<br><br><br><center>403:&nbsp; Forbidden</center><br><br>");
	}
} //ecstatic_new_hit

/***********************************************************************************/
function ecstatic_integrate() {
include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_interface.php');
ecstatic_integrate_menu();
}
/***********************************************************************************/
function ecstatic_widget_fidget() {
$ecstatic = new ecstatic();
if ($ecstatic->options["enablewidget"]) {
	include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_widget.php');
	register_widget('ecstatic_widget');
	}
} //ecstatic_widget_fidget

// Pre-2.6 compatibility
if ( ! defined( 'WP_CONTENT_URL' ) )
      define( 'WP_CONTENT_URL', get_option( 'siteurl' ) . '/wp-content' );
if ( ! defined( 'WP_CONTENT_DIR' ) )
      define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_URL' ) )
      define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );
if ( ! defined( 'WP_PLUGIN_DIR' ) )
      define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins' );

add_action('init', 'ecstatic_new_hit');
add_action('admin_menu', 'ecstatic_integrate');
add_action('widgets_init', 'ecstatic_widget_fidget');
?>