<?php
//**************************************************************************
class ecSTATic_WhoIs {

private $whois_ip_server = array(array("server"=>"whois.arin.net", "port"=>43, "string"=>"", "timed_out"=>false));

//**************************************************************************
function getCountry($ccode) {
static $cnccode = array();
$ccode = trim($ccode);
if ($ccode == "USA")
	$ccode = "US";
if (!$cnccode) {
	$country_text_file = "../wp-content/plugins/ecstatic/country_file.txt";
	if (file_exists($country_text_file)) {
		$country_file = file_get_contents($country_text_file);
		$countries = explode("\n", $country_file); //blow the file at the line ends
		foreach ($countries as $country)
			$cnccode[] = explode(";", $country);
		}
	}
if ($cnccode) {
	foreach ($cnccode as $cnc) {
		if ($ccode == $cnc[1]) {
			$found = ucwords(strtolower($cnc[0])) . " (". $cnc[1] . ")";
			return $found;
			}
		}
	}
return false;
} //getCountry

//**************************************************************************
function whois_details() {
$x = count($this->whois_ip_server) - 1;
do {
	$whois_string = $this->whois_ip_server[$x]["string"];
	$b = "<b>{$this->whois_ip_server[$x]["server"]}:{$this->whois_ip_server[$x]["port"]}</b><br />\n";
	$s = "";
	if (preg_match("/netrange:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/CIDR:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/inetnum:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/netname:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/ip-network-block:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/owner:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/org[-]*name:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/organization.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/street-address:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	elseif (preg_match("/address:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (isset($matches[1]))
		$s .= $matches[1] . "\n";
	if (preg_match("/city:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/stateprov:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/postalcode:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/postal-code:.+/i", $whois_string, $matches))
		$s .= $matches[0] . "\n";
	if (preg_match("/country[-code]*:\s*([a-z]{2,})/i", $whois_string, $matches)) { //country code
		if ($found = $this->GetCountry($matches[1]))
			$b .= "<b>{$found}</b><br />";
		else
			$s .= $matches[0] . "\n";
		}
	} while ($x-- AND $s == "");
echo "<div class='whoisbox'>\n{$b}\n{$s}</div>\n";
} //whois_details

//**************************************************************************
function whois_ip($ip) {
$i = 0;
$timeout = 4; //to open the sock
$ttimeout = $timeout * 2; //reading the stream
$faux_ip = $ip;
do {
	$again = 0;
	$optswitch = $temp = "";
	$server = $this->whois_ip_server[$i]["server"];
	if (strpos($server, "nic.ad.jp") !== false)
		$optswitch = "/e"; //suppress Japanese character output
	if ($sock = @fsockopen($server, $this->whois_ip_server[$i]["port"], $errno, $errstr, $timeout)) {
		fputs($sock, "{$faux_ip}{$optswitch}\n"); //use "-" in front of ip for ARIN whois list output, a shortened output
//		stream_set_blocking($sock, true);
		stream_set_timeout($sock, $ttimeout);
		while (!feof($sock) AND !$status['timed_out']) {
			$temp .= fgets($sock, 4096);
			$status = stream_get_meta_data($sock);
			}
		$this->whois_ip_server[$i]["timed_out"] = $status['timed_out'];
		fclose($sock);
		$this->whois_ip_server[$i]["string"] = nl2br(htmlentities(trim($temp))); //process the plook out of it
		if (preg_match("/ReferralServer:\s*([a-z]*whois:\/\/)([a-z0-9-][\.a-z0-9-]{2,})[:]*([0-9]+)*/", $temp, $arr2)) {
			if ($arr2[3] == "")
				$arr2[3] = 43;
			$this->whois_ip_server[] = array("server"=>$arr2[2], "port"=>$arr2[3], "string"=>"", "timed_out" => false);
			$again++;
			$i++;
			}
		elseif ($q = preg_match_all("/\((NET-[0-9-]*)\)/", $temp, $arr2)) {
			$this->whois_ip_server[] = $this->whois_ip_server[$i];
			$faux_ip = $arr2[1][$q-1];
			$again++;
			$i++;
			}
		}
	else {
		$this->whois_ip_server[$i]["string"] = "Errno: {$errno}  Error: ({$errstr}) connecting to {$this->whois_ip_server[$i]["server"]} (port {$this->whois_ip_server[$i]["port"]})";
		unset($sock);
		}
	} while ($again AND $i < 5); //forbid endless loops, no?
} //whois_ip

//**************************************************************************
function __construct($ip) {
if ((strlen($ip) < 1) OR (strlen($ip) > 16))
	exit("Expected Parameter Not Found.");
$this->whois_ip($ip);
}
} //ecSTATic_WhoIs
//**************************************************************************

$BooWho = new ecSTATic_WhoIs($rec->ip->ip);
echo "<div id='whois'>\n";
$BooWho->whois_details();
if (file_exists("../wp-content/plugins/ecstatic/GeoLiteCity.dat")) {
	include("../wp-content/plugins/ecstatic/geoipcity.inc");
	$gi = geoip_open("../wp-content/plugins/ecstatic/GeoLiteCity.dat", GEOIP_STANDARD);
	$record = geoip_record_by_addr($gi, $rec->ip->ip);
	echo "<div class='whoisbox'>\n";
	echo "<p>Via <a href='http://www.maxmind.com/app/ip-location' target='blank'>MaxMind's GeoIP APIs</a></p>\n";
	echo "<b>City:</b> ". $record->city . "<br />\n";
	echo "<b>Region:</b> ". $GEOIP_REGION_NAME[$record->country_code][$record->region] . " &mdash; " . $record->region . "<br />\n";
	echo "<b>Postal Code:</b> " . $record->postal_code . "&nbsp;&nbsp;&nbsp; ";
	echo "<b>Area code:</b> " . $record->area_code . "<br />\n";
	echo "<b>Country:</b> " . $record->country_name . " " . $record->country_code . " " . $record->country_code3 . "<br />\n";
	echo "<b>Latitude:</b> " . sprintf("%0.4f", $record->latitude) . "<br />\n";
	echo "<b>Longitude:</b> " . sprintf("%0.4f", $record->longitude) . "<br />\n";
	echo "[<a href='http://maps.google.com/maps?q=loc:{$record->latitude}+{$record->longitude}&amp;z=7' title='Google Maps lat={$record->latitude} lon={$record->longitude}' target='blank'>GoogleMap</a>]<br />\n";
	echo "</div>\n";
	geoip_close($gi);
	}
elseif (file_exists("../wp-content/plugins/ecstatic/geoplugin.class.php")) {
	include("../wp-content/plugins/ecstatic/geoplugin.class.php");
	$geoplugin = new geoPlugin();
	$geoplugin->locate($rec->ip->ip);
	echo "<div class='whoisbox'>\n";
	echo "<p><a href='http://www.geoplugin.com/' target='_new' title='geoPlugin for IP geolocation'>Geolocation by geoPlugin</a></p>\n";
	echo "<b>City:</b> ". $geoplugin->city . "<br />\n";
	echo "<b>Region:</b> ". $geoplugin->region . "<br />\n";
	echo "<b>Area code:</b> " . $geoplugin->areaCode . "&nbsp;&nbsp;&nbsp; ";
	echo "<b>DMA code:</b> " . $geoplugin->dmaCode . "<br />\n";
	echo "<b>Country:</b> " . $geoplugin->countryName . " (" . $geoplugin->countryCode . ")<br />\n";
	echo "<b>Continent Code:</b> " . $geoplugin->continentCode . "<br />\n";
	echo "<b>Latitude:</b> " . sprintf("%0.4f", $geoplugin->latitude) . "<br />\n";
	echo "<b>Longitude:</b> " . sprintf("%0.4f", $geoplugin->longitude) . "<br />\n";
	echo "[<a href='http://maps.google.com/maps?q=loc:{$geoplugin->latitude}+{$geoplugin->longitude}&amp;z=7' title='Google Maps lat={$record->latitude} lon={$record->longitude}' target='blank'>GoggleMap</a>]<br />\n";
	echo "</div>\n";
	}
echo "<div class='clear'></div>\n";
echo "</div><!--whois-->\n\n";
?>